package cn.com.qmth.examcloud.ws.core;

import java.io.IOException;
import java.util.List;
import java.util.Map;

import javax.websocket.OnClose;
import javax.websocket.OnError;
import javax.websocket.OnMessage;
import javax.websocket.OnOpen;
import javax.websocket.Session;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;

import org.springframework.stereotype.Component;

import cn.com.qmth.examcloud.commons.util.DateUtil;

@ServerEndpoint("/{path}")
@Component
public class WebSocketServerEndpoint {

	@OnOpen
	public void onOpen(Session session, @PathParam("path") String path) {
		System.out.println("onOpen; session=" + session + "; path=" + path);
		try {
			session.getBasicRemote().sendText(DateUtil.chinaNow() + "| fuck");
		} catch (IOException e) {
			e.printStackTrace();
		}

		Map<String, List<String>> params = session.getRequestParameterMap();
		String key = params.get("key").get(0);
		String token = params.get("token").get(0);
		System.out.println("key=" + key);
		System.out.println("token=" + token);
	}

	@OnClose
	public void onClose(Session session, @PathParam("path") String path) {
		System.out.println("onClose; session=" + session + "; path=" + path);
	}

	@OnMessage
	public void onMessage(Session session, @PathParam("path") String path, String message) {
		System.out.println("onMessage; session=" + session + "; path=" + path);
		System.out.println("onMessage; message=" + message);
	}

	@OnError
	public void onError(Session session, @PathParam("path") String path, Throwable t) {
		System.out.println("onError; session=" + session + "; path=" + path);
		t.printStackTrace();
	}

}
